//definicje
#define CLK 2//enkoder
#define DT 4//enkoder
#define AOUT A0//czujnik wilgotnosci
#define WODA A7//czujnik poziomu wody
#define IN1 A1//przełącznik
#define SW 3//przycisk
//biblioteki
#include <Encoder.h>
#include <SPI.h>
#include <Wire.h>
#include <Adafruit_GFX.h>
#include <Adafruit_SSD1306.h>
//obiekty
Adafruit_SSD1306 display(0);
Encoder myEnc(CLK, DT);
//zmienne
const int mokry = 805; //wartosc suchego czujnika wilgotnosci
const int suchy = 390; //wartosc mokrego czujnika wilgotnosci
int odczyt = analogRead(AOUT);//odczyt z czujnika poziomu cieczy
int wilgotnosc = 0;//odczyt z czujnika wilgotnosci
long ustaw_wilgotnosc = 0;//odczytujemy wartość z enkodera
long poprzednia_wartosc = 0;//zmienna pomocnicza do enkodera
bool zmiana = true;//czy jest zmieniana wilgotnosc
int ilosc_wody = 0;//poziom wody
volatile bool uspiony = false;//zmienna odpowiadajaca za tryb uspienia
unsigned long obecny_czas = 0;//zmienna do mierzenia obecnego czasu
unsigned long ostatni_czas = 0;//ostatni mierzony czas
volatile bool wcisniety = false;
//grafika
const unsigned char kropla_wody [] PROGMEM = {
  0x00, 0x00, 0x80, 0x00, 0x00, 0x01, 0xc0, 0x00, 0x00, 0x03, 0xc0, 0x00, 0x00, 0x03, 0xc0, 0x00,
  0x00, 0x07, 0xc0, 0x00, 0x00, 0x0f, 0xc0, 0x00, 0x00, 0x1f, 0xe0, 0x00, 0x00, 0x1c, 0xe0, 0x00,
  0x00, 0x3c, 0xf0, 0x00, 0x00, 0x78, 0x70, 0x00, 0x00, 0x70, 0x78, 0x00, 0x00, 0xf0, 0x3c, 0x00,
  0x00, 0xe0, 0x1e, 0x00, 0x01, 0xe0, 0x1e, 0x00, 0x01, 0xc0, 0x0f, 0x00, 0x03, 0xc0, 0x07, 0x80,
  0x03, 0xd0, 0x07, 0x80, 0x03, 0x90, 0x03, 0xc0, 0x03, 0xb0, 0x01, 0xc0, 0x07, 0xb0, 0x01, 0xe0,
  0x07, 0xb0, 0x01, 0xe0, 0x07, 0x30, 0x00, 0xe0, 0x07, 0xb0, 0x01, 0xe0, 0x03, 0xb8, 0x01, 0xc0,
  0x03, 0x98, 0x01, 0xc0, 0x03, 0xcc, 0x03, 0xc0, 0x01, 0xc7, 0x03, 0x80, 0x01, 0xf0, 0x0f, 0x80,
  0x00, 0xfc, 0x3f, 0x00, 0x00, 0x7f, 0xfe, 0x00, 0x00, 0x1f, 0xf8, 0x00, 0x00, 0x0f, 0xf0, 0x00
};

void setup() {
  Serial.begin(9600);//rozpoczęcie transmisji na porcie szeregowym
  display.begin(SSD1306_SWITCHCAPVCC, 0x3C);//definiujemy rodzaj użytego wyświetlacza oraz adres I2C
  display.clearDisplay();//czyścimy ekran
  display.setTextSize(3);// ustawiamy rozmiar czcionki
  display.setTextColor(WHITE);//ustawiamy kolor biały
  pinMode(IN1, OUTPUT);//ustawienie pinu IN1 jako wyjście
  pinMode(SW, INPUT_PULLUP);//ustawienie pinu SW jako przycisk
  attachInterrupt(digitalPinToInterrupt(SW), Wybudz , FALLING);//ustawiamy przerwanie na przycisk ktore ma wykonac funkcje wybudz
}

void loop() {
  while (!uspiony) {
    display.ssd1306_command(SSD1306_DISPLAYON);//włączenie wyświetlacza lcd jeżeli był wcześniej wyłączony

    myEnc.write(poprzednia_wartosc);//ustaw poprzednią warto

    while (wcisniety) {
      long ustaw_wilgotnosc = myEnc.read();//odczytujemy wartość z enkodera
      if (ustaw_wilgotnosc < 0) { //jeżeli wartość z enkodera jest mniejsza od 0 ustaw ją na 0
        myEnc.write(0);//ustawiamy pozycję enkodera na 0
      } else if (ustaw_wilgotnosc > 100) {//w przeciwnym wypadku jeżeli wartość jest większa od 100 ustaw ją na 100
        myEnc.write(100);//ustawiamy pozycję enkodera na 100
      }
      //Ponownie wczytujemy wartości z enkodera
      ustaw_wilgotnosc = myEnc.read();//wczytaj ponownie wartość enkodera w razie gdyby uległa ona zmianie przez instrukcje warunkowe

      //Wyświetlamy pobraną wartość na wyświetlaczu
      display.clearDisplay();//czyścimy ekran
      display.setCursor(4, 0);//ustawiamy kursor na daną pozycję
      display.setTextSize(2);// ustawiamy rozmiar czcionki
      display.writeFastHLine(0, 16, 128, WHITE);//rysujemy białą linię, dwa pierwsze parametry odpowiadają za szerokość i wysokość, pozostałe dwa za szerokość lini oraz kolor
      display.println("USTAW WIL.");//piszemy tekst który ma się ukazać
      display.setTextSize(3);// ustawiamy rozmiar czcionki
      display.setCursor(50, 22);//ustawiamy kursor na daną pozycję
      display.print(ustaw_wilgotnosc);//wyświetlamy wcześniej ustawioną wilgotność
      display.print("%");//piszemy tekst który ma się ukazać
      display.display();//wyświetlamy

      poprzednia_wartosc = ustaw_wilgotnosc;//przypisujemy obecną ustawioną wilgotność, aby później

      delay(50);
    }

    ilosc_wody = analogRead(WODA);
    while (ilosc_wody < 50) {
      display.clearDisplay();//czyścimy ekran
      display.drawBitmap(5, 18, kropla_wody, 32, 32, WHITE);//pierwsze dwa parametry odpowiadają za ustawienie kursora, nazwa oznacza nazwę naszego kodu obrazka, a 128 i 64 to rozmiar obrazka, na końcu ustawiamy kolor WHITE czyli biały
      display.setTextSize(2);// ustawiamy rozmiar czcionki
      display.setCursor(42, 18);//ustawiamy kursor na daną pozycję
      display.print("NALEJ");//piszemy tekst który ma się ukazać
      display.setCursor(42, 35);//ustawiamy kursor na daną pozycję
      display.print("WODY");//piszemy tekst który ma się ukazać
      display.display();//wyświetlamy na ekranie, bez tego nie zadziała
      delay(100);
      ilosc_wody = analogRead(WODA);
    }

    if (wilgotnosc < ustaw_wilgotnosc) {
      digitalWrite(IN1, LOW);
      delay(2000);
      digitalWrite(IN1, HIGH);
      delay(5000);
    } else {
      digitalWrite(IN1, HIGH);
    }
    ZrobOdczytWilgotnosci();
    WyswietlWilgotnosc();


    if (obecny_czas - ostatni_czas > 30000) {
      ostatni_czas = obecny_czas;
      uspiony = true;
    } else {
      obecny_czas = millis();
    }
  }
  while (uspiony)
  {
    display.ssd1306_command(SSD1306_DISPLAYOFF);//wyłączenie wyświetlacza lcd

    ZrobOdczytWilgotnosci();

    if (wilgotnosc < ustaw_wilgotnosc) {
      digitalWrite(IN1, LOW);
      delay(2000);
      digitalWrite(IN1, HIGH);
      delay(5000);
    } else {
      digitalWrite(IN1, HIGH);
    }
    delay(1000);
  }
}

void Uspij() {
  uspiony = true;
}
void Wybudz() {
  uspiony = false;
  wcisniety = !wcisniety;
}
void ZrobOdczytWilgotnosci() {
  int odczyt = analogRead(AOUT);//zadeklarowanie i wczytanie do zmiennej wartości z czujnika
  wilgotnosc = map(odczyt, suchy, mokry, 100, 0);//zmapowanie odczytywanych wartości na procenty
}
void WyswietlWilgotnosc() {
  display.clearDisplay();//czyścimy ekran
  display.setCursor(4, 0);//ustawiamy kursor na daną pozycję
  display.setTextSize(2);// ustawiamy rozmiar czcionki
  display.writeFastHLine(0, 16, 128, WHITE);//rysujemy białą linię, dwa pierwsze parametry odpowiadają za szerokość i wysokość, pozostałe dwa za szerokość lini oraz kolor
  display.println("WILGOTNOSC");//piszemy tekst który ma się ukazać
  display.setTextSize(3);// ustawiamy rozmiar czcionki
  display.setCursor(50, 22);//ustawiamy kursor na daną pozycję
  display.print(wilgotnosc);//piszemy tekst który ma się ukazać
  display.print("%");//piszemy tekst który ma się ukazać
  display.display();//wyświetlamy
  delay(10);
}
